=== debian/changelog ===
micropython (1.24.1+ds-1) unstable; urgency=medium

  * New upstream release
  * Fix FTBFS on i386 (Closes: #1099512)
  * Ship mip (Closes: #1043530)
  * Decrease the mbedTLS DEBUG level (Closes: #1088284)
  * Bump Standards-Version to 4.7.2

 -- Yangfl <mmyangfl@gmail.com>  Sat, 08 Mar 2025 17:06:28 +0800
